# EvCheckout

## PreStage Methods

### authUser

Used to protect that stage from used that are not yet logged in.

### loadAddresses

Used with EvAddressBook. Loads all a logged in users stored address and sets to template so they can select an existing address without adding a new one.

Used in conjunction with PostStage - processDeliveryAddress / processBillingAddress(TBC)

### loadBasket

Used with EvBasket. Loads a users basket for use on a confirm page.

### loadSelectedAddresses

Load the saved addresses within the session EvCheckout.address, for displaying on the page.

### processBasketShipping

Used with EvBasket and EvShipping. Used to calculate the shipping based on the users basket and the selected delivery address

## PostStage Methods

### processRegister

Used to process a new users registration. Can handle full registration or guest checkout

### processLogin

Used to login an existing user

### processDeliveryAddress

Used to process a delivery address, either by selecting an existing one or adding a new one and then selecting it.

Used with EvAddressBook and the PreStage method - loadAddresses

## Sessions

### EvCheckout.stageProcess

A session can be set with this name with the contents of the session being the key of one of the stage processes from the EvCheckout Config.

This should allow things like a custom admin process to be run.

Upon completion of any Checkouts in that scenario remember to delete the session

### EvCheckout.address

A session set to hold to the selected delivery / billing address ID numbers (used in conjunction with EvAddressBook).

* EvCheckout.address.delivery - contains the id selected for delivery address
* EvCheckout.address.billing - contains the id selected for billing address

## Events

### EvCheckout.Controller.Checkout.successful

Called on the success page of the checkout

#### Parameters

No parameters passed

### EvCheckout.Controller.Checkout.failed

Called on the fail page of the checkout

#### Parameters

No parameters passed